Index: drivers/filesystems/btrfs/treefuncs.c
===================================================================
--- drivers/filesystems/btrfs/treefuncs.c	(révision 75772)
+++ drivers/filesystems/btrfs/treefuncs.c	(copie de travail)
@@ -1,25 +1,23 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include "btrfs_drv.h"
 
-// #define DEBUG_TREE_LOCKS
-
-NTSTATUS STDCALL _load_tree(device_extension* Vcb, UINT64 addr, root* r, tree** pt, tree* parent, PIRP Irp, const char* func, const char* file, unsigned int line) {
+NTSTATUS load_tree(device_extension* Vcb, UINT64 addr, root* r, tree** pt, UINT64 generation, PIRP Irp) {
     UINT8* buf;
     NTSTATUS Status;
     tree_header* th;
@@ -29,24 +27,22 @@
     UINT8 h;
     BOOL inserted;
     LIST_ENTRY* le;
-    
-    TRACE("(%p, %llx)\n", Vcb, addr);
-    
+
     buf = ExAllocatePoolWithTag(PagedPool, Vcb->superblock.node_size, ALLOC_TAG);
     if (!buf) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    Status = read_data(Vcb, addr, Vcb->superblock.node_size, NULL, TRUE, buf, NULL, &c, Irp, FALSE);
+
+    Status = read_data(Vcb, addr, Vcb->superblock.node_size, NULL, TRUE, buf, NULL, &c, Irp, generation, FALSE, NormalPagePriority);
     if (!NT_SUCCESS(Status)) {
         ERR("read_data returned 0x%08x\n", Status);
         ExFreePool(buf);
         return Status;
     }
-    
+
     th = (tree_header*)buf;
-    
+
     t = ExAllocatePoolWithTag(PagedPool, sizeof(tree), ALLOC_TAG);
     if (!t) {
         ERR("out of memory\n");
@@ -53,16 +49,13 @@
         ExFreePool(buf);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(&t->header, th, sizeof(tree_header));
-//     t->address = addr;
-//     t->level = th->level;
     t->hash = calc_crc32c(0xffffffff, (UINT8*)&addr, sizeof(UINT64));
     t->has_address = TRUE;
     t->Vcb = Vcb;
     t->parent = NULL;
     t->root = r;
-//     t->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(tree_nonpaged), ALLOC_TAG);
     t->paritem = NULL;
     t->size = 0;
     t->new_address = 0;
@@ -69,22 +62,20 @@
     t->has_new_address = FALSE;
     t->updated_extents = FALSE;
     t->write = FALSE;
-    
-//     ExInitializeResourceLite(&t->nonpaged->load_tree_lock);
-    
-//     t->items = ExAllocatePoolWithTag(PagedPool, num_items * sizeof(tree_data), ALLOC_TAG);
+    t->uniqueness_determined = FALSE;
+
     InitializeListHead(&t->itemlist);
-    
+
     if (t->header.level == 0) { // leaf node
         leaf_node* ln = (leaf_node*)(buf + sizeof(tree_header));
         unsigned int i;
-        
+
         if ((t->header.num_items * sizeof(leaf_node)) + sizeof(tree_header) > Vcb->superblock.node_size) {
             ERR("tree at %llx has more items than expected (%x)\n", t->header.num_items);
             ExFreePool(buf);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         for (i = 0; i < t->header.num_items; i++) {
             td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
             if (!td) {
@@ -92,42 +83,41 @@
                 ExFreePool(buf);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             td->key = ln[i].key;
-//             TRACE("load_tree: leaf item %u (%x,%x,%x)\n", i, (UINT32)ln[i].key.obj_id, ln[i].key.obj_type, (UINT32)ln[i].key.offset);
-            
-            if (ln[i].size > 0) {
-                td->data = ExAllocatePoolWithTag(PagedPool, ln[i].size, ALLOC_TAG);
-                if (!td->data) {
-                    ERR("out of memory\n");
-                    ExFreePool(buf);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                RtlCopyMemory(td->data, buf + sizeof(tree_header) + ln[i].offset, ln[i].size);
-            } else
+
+            if (ln[i].size > 0)
+                td->data = buf + sizeof(tree_header) + ln[i].offset;
+            else
                 td->data = NULL;
-            
-            td->size = ln[i].size;
+
+            if (ln[i].size + sizeof(tree_header) + sizeof(leaf_node) > Vcb->superblock.node_size) {
+                ERR("overlarge item in tree %llx: %u > %u\n", addr, ln[i].size, Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node));
+                ExFreePool(buf);
+                return STATUS_INTERNAL_ERROR;
+            }
+
+            td->size = (UINT16)ln[i].size;
             td->ignore = FALSE;
             td->inserted = FALSE;
-            
+
             InsertTailList(&t->itemlist, &td->list_entry);
-            
+
             t->size += ln[i].size;
         }
-        
+
         t->size += t->header.num_items * sizeof(leaf_node);
+        t->buf = buf;
     } else {
         internal_node* in = (internal_node*)(buf + sizeof(tree_header));
         unsigned int i;
-        
+
         if ((t->header.num_items * sizeof(internal_node)) + sizeof(tree_header) > Vcb->superblock.node_size) {
             ERR("tree at %llx has more items than expected (%x)\n", t->header.num_items);
             ExFreePool(buf);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         for (i = 0; i < t->header.num_items; i++) {
             td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
             if (!td) {
@@ -135,35 +125,32 @@
                 ExFreePool(buf);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             td->key = in[i].key;
-//             TRACE("load_tree: internal item %u (%x,%x,%x)\n", i, (UINT32)in[i].key.obj_id, in[i].key.obj_type, (UINT32)in[i].key.offset);
-            
+
             td->treeholder.address = in[i].address;
             td->treeholder.generation = in[i].generation;
             td->treeholder.tree = NULL;
-//             td->treeholder.nonpaged->status = tree_holder_unloaded;
             td->ignore = FALSE;
             td->inserted = FALSE;
-            
+
             InsertTailList(&t->itemlist, &td->list_entry);
         }
-        
+
         t->size = t->header.num_items * sizeof(internal_node);
+        t->buf = NULL;
+        ExFreePool(buf);
     }
-    
-    ExFreePool(buf);
-    
-    InterlockedIncrement(&Vcb->open_trees);
+
     InsertTailList(&Vcb->trees, &t->list_entry);
-    
+
     h = t->hash >> 24;
-    
+
     if (!Vcb->trees_ptrs[h]) {
         UINT8 h2 = h;
-        
+
         le = Vcb->trees_hash.Flink;
-        
+
         if (h2 > 0) {
             h2--;
             do {
@@ -171,23 +158,23 @@
                     le = Vcb->trees_ptrs[h2];
                     break;
                 }
-                    
+
                 h2--;
             } while (h2 > 0);
         }
     } else
         le = Vcb->trees_ptrs[h];
-    
+
     inserted = FALSE;
     while (le != &Vcb->trees_hash) {
         tree* t2 = CONTAINING_RECORD(le, tree, list_entry_hash);
-        
+
         if (t2->hash >= t->hash) {
             InsertHeadList(le->Blink, &t->list_entry_hash);
             inserted = TRUE;
             break;
         }
-        
+
         le = le->Flink;
     }
 
@@ -196,68 +183,48 @@
 
     if (!Vcb->trees_ptrs[h] || t->list_entry_hash.Flink == Vcb->trees_ptrs[h])
         Vcb->trees_ptrs[h] = &t->list_entry_hash;
-    
+
     TRACE("returning %p\n", t);
-    
+
     *pt = t;
-    
+
     return STATUS_SUCCESS;
 }
 
-static tree* free_tree2(tree* t, const char* func, const char* file, unsigned int line) {
-    LIST_ENTRY* le;
-    tree_data* td;
+static tree* free_tree2(tree* t) {
     tree* par;
     root* r = t->root;
-    
+
     par = t->parent;
-    
-//     if (par) ExAcquireResourceExclusiveLite(&par->nonpaged->load_tree_lock, TRUE);
-    
+
     if (r && r->treeholder.tree != t)
         r = NULL;
-    
-//         if (r) {
-//             FsRtlEnterFileSystem();
-//             ExAcquireResourceExclusiveLite(&r->nonpaged->load_tree_lock, TRUE);
-//         }
-    
+
     if (par) {
         if (t->paritem)
             t->paritem->treeholder.tree = NULL;
-        
-//             ExReleaseResourceLite(&par->nonpaged->load_tree_lock);
     }
-    
-//         ExDeleteResourceLite(&t->nonpaged->load_tree_lock);
-    
-//         ExFreePool(t->nonpaged);
-    
+
     while (!IsListEmpty(&t->itemlist)) {
-        le = RemoveHeadList(&t->itemlist);
-        td = CONTAINING_RECORD(le, tree_data, list_entry);
-        
-        if (t->header.level == 0 && td->data)
+        tree_data* td = CONTAINING_RECORD(RemoveHeadList(&t->itemlist), tree_data, list_entry);
+
+        if (t->header.level == 0 && td->data && td->inserted)
             ExFreePool(td->data);
-            
+
         ExFreeToPagedLookasideList(&t->Vcb->tree_data_lookaside, td);
     }
-    
-    InterlockedDecrement(&t->Vcb->open_trees);
+
     RemoveEntryList(&t->list_entry);
-    
-    if (r) {
+
+    if (r)
         r->treeholder.tree = NULL;
-//             ExReleaseResourceLite(&r->nonpaged->load_tree_lock);
-//             FsRtlExitFileSystem();
-    }
-    
+
     if (t->list_entry_hash.Flink) {
         UINT8 h = t->hash >> 24;
         if (t->Vcb->trees_ptrs[h] == &t->list_entry_hash) {
             if (t->list_entry_hash.Flink != &t->Vcb->trees_hash) {
                 tree* t2 = CONTAINING_RECORD(t->list_entry_hash.Flink, tree, list_entry_hash);
-                
+
                 if ((t2->hash >> 24) == h)
                     t->Vcb->trees_ptrs[h] = &t2->list_entry_hash;
                 else
@@ -265,141 +232,211 @@
             } else
                 t->Vcb->trees_ptrs[h] = NULL;
         }
-        
+
         RemoveEntryList(&t->list_entry_hash);
     }
-    
+
+    if (t->buf)
+        ExFreePool(t->buf);
+
     ExFreePool(t);
 
     return NULL;
 }
 
-NTSTATUS STDCALL _do_load_tree(device_extension* Vcb, tree_holder* th, root* r, tree* t, tree_data* td, BOOL* loaded, PIRP Irp,
-                               const char* func, const char* file, unsigned int line) {
-//     KIRQL irql;
-//     tree_holder_nonpaged* thnp = th->nonpaged;
+NTSTATUS do_load_tree(device_extension* Vcb, tree_holder* th, root* r, tree* t, tree_data* td, BOOL* loaded, PIRP Irp) {
     BOOL ret;
-    
-//     ExAcquireResourceExclusiveLite(&thnp->lock, TRUE);
+
     ExAcquireResourceExclusiveLite(&r->nonpaged->load_tree_lock, TRUE);
-    
-//     KeAcquireSpinLock(&thnp->spin_lock, &irql);
-//     
-//     if (thnp->status == tree_header_loading) {
-//         KeReleaseSpinLock(&thnp->spin_lock, irql);
-//         
-//         // FIXME - wait for Event
-//     } else if (thnp->status == tree_header_unloaded || thnp->status == tree_header_unloading) {
-//         if (thnp->status == tree_header_unloading) {
-//             KeReleaseSpinLock(&thnp->spin_lock, irql);
-//             // FIXME - wait for Event
-//         }
-//         
-//         // FIXME - change status
-//         thnp->status = tree_header_loading;
-//         KeReleaseSpinLock(&thnp->spin_lock, irql);
-//         
-//         // FIXME - load
-//         // FIXME - change status
-//         // FIXME - trigger event
-//     } else if (thnp->status == tree_header_loaded) {
-//         _increase_tree_rc(th->tree, func, file, line);
-//         KeReleaseSpinLock(&thnp->spin_lock, irql);
-//         
-//         ret = FALSE;
-//     }
 
     if (!th->tree) {
         NTSTATUS Status;
-        
-        Status = _load_tree(Vcb, th->address, r, &th->tree, t, Irp, func, file, line);
+        tree* nt;
+
+        Status = load_tree(Vcb, th->address, r, &nt, th->generation, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("load_tree returned %08x\n", Status);
             ExReleaseResourceLite(&r->nonpaged->load_tree_lock);
             return Status;
         }
-        
-        th->tree->parent = t;
-        
+
+        nt->parent = t;
+
 #ifdef DEBUG_PARANOID
-        if (t && t->header.level <= th->tree->header.level) int3;
+        if (t && t->header.level <= nt->header.level) int3;
 #endif
-        
-        th->tree->paritem = td;
-        
+
+        nt->paritem = td;
+
+        th->tree = nt;
+
         ret = TRUE;
     } else
         ret = FALSE;
-    
-//     KeReleaseSpinLock(&thnp->spin_lock, irql);
-    
-//     ExReleaseResourceLite(&thnp->lock);
+
     ExReleaseResourceLite(&r->nonpaged->load_tree_lock);
-    
+
     *loaded = ret;
-    
+
     return STATUS_SUCCESS;
 }
 
-tree* STDCALL _free_tree(tree* t, const char* func, const char* file, unsigned int line) {
+tree* free_tree(tree* t) {
     tree* ret;
     root* r = t->root;
-    
+
     ExAcquireResourceExclusiveLite(&r->nonpaged->load_tree_lock, TRUE);
 
-    ret = free_tree2(t, func, file, line);
+    ret = free_tree2(t);
 
     ExReleaseResourceLite(&r->nonpaged->load_tree_lock);
-    
+
     return ret;
 }
 
 static __inline tree_data* first_item(tree* t) {
     LIST_ENTRY* le = t->itemlist.Flink;
-    
+
     if (le == &t->itemlist)
         return NULL;
-    
+
     return CONTAINING_RECORD(le, tree_data, list_entry);
 }
 
 static __inline tree_data* prev_item(tree* t, tree_data* td) {
     LIST_ENTRY* le = td->list_entry.Blink;
-    
+
     if (le == &t->itemlist)
         return NULL;
-    
+
     return CONTAINING_RECORD(le, tree_data, list_entry);
 }
 
 static __inline tree_data* next_item(tree* t, tree_data* td) {
     LIST_ENTRY* le = td->list_entry.Flink;
-    
+
     if (le == &t->itemlist)
         return NULL;
-    
+
     return CONTAINING_RECORD(le, tree_data, list_entry);
 }
 
-static NTSTATUS STDCALL find_item_in_tree(device_extension* Vcb, tree* t, traverse_ptr* tp, const KEY* searchkey, BOOL ignore, UINT8 level, PIRP Irp,
-                                          const char* func, const char* file, unsigned int line) {
+static NTSTATUS next_item2(device_extension* Vcb, tree* t, tree_data* td, traverse_ptr* tp) {
+    tree_data* td2 = next_item(t, td);
+    tree* t2;
+
+    if (td2) {
+        tp->tree = t;
+        tp->item = td2;
+        return STATUS_SUCCESS;
+    }
+
+    t2 = t;
+
+    do {
+        td2 = t2->paritem;
+        t2 = t2->parent;
+    } while (td2 && !next_item(t2, td2));
+
+    if (!td2)
+        return STATUS_NOT_FOUND;
+
+    td2 = next_item(t2, td2);
+
+    return find_item_to_level(Vcb, t2->root, tp, &td2->key, FALSE, t->header.level, NULL);
+}
+
+NTSTATUS skip_to_difference(device_extension* Vcb, traverse_ptr* tp, traverse_ptr* tp2, BOOL* ended1, BOOL* ended2) {
+    NTSTATUS Status;
+    tree *t1, *t2;
+    tree_data *td1, *td2;
+
+    t1 = tp->tree;
+    t2 = tp2->tree;
+
+    do {
+        td1 = t1->paritem;
+        td2 = t2->paritem;
+        t1 = t1->parent;
+        t2 = t2->parent;
+    } while (t1 && t2 && t1->header.address == t2->header.address);
+
+    while (TRUE) {
+        traverse_ptr tp3, tp4;
+
+        Status = next_item2(Vcb, t1, td1, &tp3);
+        if (Status == STATUS_NOT_FOUND)
+            *ended1 = TRUE;
+        else if (!NT_SUCCESS(Status)) {
+            ERR("next_item2 returned %08x\n", Status);
+            return Status;
+        }
+
+        Status = next_item2(Vcb, t2, td2, &tp4);
+        if (Status == STATUS_NOT_FOUND)
+            *ended2 = TRUE;
+        else if (!NT_SUCCESS(Status)) {
+            ERR("next_item2 returned %08x\n", Status);
+            return Status;
+        }
+
+        if (*ended1 || *ended2) {
+            if (!*ended1) {
+                Status = find_item(Vcb, t1->root, tp, &tp3.item->key, FALSE, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("find_item returned %08x\n", Status);
+                    return Status;
+                }
+            } else if (!*ended2) {
+                Status = find_item(Vcb, t2->root, tp2, &tp4.item->key, FALSE, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("find_item returned %08x\n", Status);
+                    return Status;
+                }
+            }
+
+            return STATUS_SUCCESS;
+        }
+
+        if (tp3.tree->header.address != tp4.tree->header.address) {
+            Status = find_item(Vcb, t1->root, tp, &tp3.item->key, FALSE, NULL);
+            if (!NT_SUCCESS(Status)) {
+                ERR("find_item returned %08x\n", Status);
+                return Status;
+            }
+
+            Status = find_item(Vcb, t2->root, tp2, &tp4.item->key, FALSE, NULL);
+            if (!NT_SUCCESS(Status)) {
+                ERR("find_item returned %08x\n", Status);
+                return Status;
+            }
+
+            return STATUS_SUCCESS;
+        }
+
+        t1 = tp3.tree;
+        td1 = tp3.item;
+        t2 = tp4.tree;
+        td2 = tp4.item;
+    }
+}
+
+static NTSTATUS find_item_in_tree(device_extension* Vcb, tree* t, traverse_ptr* tp, const KEY* searchkey, BOOL ignore, UINT8 level, PIRP Irp) {
     int cmp;
     tree_data *td, *lasttd;
     KEY key2;
-    
-    TRACE("(%p, %p, %p, %p, %u)\n", Vcb, t, tp, searchkey, ignore);
-    
+
     cmp = 1;
     td = first_item(t);
     lasttd = NULL;
-    
+
     if (!td) return STATUS_NOT_FOUND;
-    
+
     key2 = *searchkey;
-    
+
     do {
         cmp = keycmp(key2, td->key);
-//         TRACE("(%u) comparing (%x,%x,%x) to (%x,%x,%x) - %i (ignore = %s)\n", t->header.level, (UINT32)searchkey->obj_id, searchkey->obj_type, (UINT32)searchkey->offset, (UINT32)td->key.obj_id, td->key.obj_type, (UINT32)td->key.offset, cmp, td->ignore ? "TRUE" : "FALSE");
+
         if (cmp == 1) {
             lasttd = td;
             td = next_item(t, td);
@@ -407,13 +444,13 @@
 
         if (t->header.level == 0 && cmp == 0 && !ignore && td && td->ignore) {
             tree_data* origtd = td;
-            
+
             while (td && td->ignore)
                 td = next_item(t, td);
-            
+
             if (td) {
                 cmp = keycmp(key2, td->key);
-                
+
                 if (cmp != 0) {
                     td = origtd;
                     cmp = 0;
@@ -422,84 +459,81 @@
                 td = origtd;
         }
     } while (td && cmp == 1);
-    
+
     if ((cmp == -1 || !td) && lasttd)
         td = lasttd;
-    
+
     if (t->header.level == 0) {
         if (td->ignore && !ignore) {
             traverse_ptr oldtp;
-            
+
             oldtp.tree = t;
             oldtp.item = td;
-            
-            while (_find_prev_item(Vcb, &oldtp, tp, TRUE, Irp, func, file, line)) {
+
+            while (find_prev_item(Vcb, &oldtp, tp, Irp)) {
                 if (!tp->item->ignore)
                     return STATUS_SUCCESS;
-                
+
                 oldtp = *tp;
             }
-            
+
             // if no valid entries before where item should be, look afterwards instead
-            
+
             oldtp.tree = t;
             oldtp.item = td;
-            
-            while (_find_next_item(Vcb, &oldtp, tp, TRUE, Irp, func, file, line)) {
+
+            while (find_next_item(Vcb, &oldtp, tp, TRUE, Irp)) {
                 if (!tp->item->ignore)
                     return STATUS_SUCCESS;
-                
+
                 oldtp = *tp;
             }
-            
+
             return STATUS_NOT_FOUND;
         } else {
             tp->tree = t;
             tp->item = td;
         }
-        
+
         return STATUS_SUCCESS;
     } else {
         NTSTATUS Status;
         BOOL loaded;
-        
+
         while (td && td->treeholder.tree && IsListEmpty(&td->treeholder.tree->itemlist)) {
             td = prev_item(t, td);
         }
-        
+
         if (!td)
             return STATUS_NOT_FOUND;
-        
+
         if (t->header.level <= level) {
             tp->tree = t;
             tp->item = td;
             return STATUS_SUCCESS;
         }
-        
-//         if (i > 0)
-//             TRACE("entering tree from (%x,%x,%x) to (%x,%x,%x) (%p)\n", (UINT32)t->items[i].key.obj_id, t->items[i].key.obj_type, (UINT32)t->items[i].key.offset, (UINT32)t->items[i+1].key.obj_id, t->items[i+1].key.obj_type, (UINT32)t->items[i+1].key.offset, t->items[i].tree);
-        
-        Status = _do_load_tree(Vcb, &td->treeholder, t->root, t, td, &loaded, Irp, func, file, line);
-        if (!NT_SUCCESS(Status)) {
-            ERR("do_load_tree returned %08x\n", Status);
-            return Status;
+
+        if (!td->treeholder.tree) {
+            Status = do_load_tree(Vcb, &td->treeholder, t->root, t, td, &loaded, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("do_load_tree returned %08x\n", Status);
+                return Status;
+            }
         }
-        
-        Status = find_item_in_tree(Vcb, td->treeholder.tree, tp, searchkey, ignore, level, Irp, func, file, line);
-        
+
+        Status = find_item_in_tree(Vcb, td->treeholder.tree, tp, searchkey, ignore, level, Irp);
+
         return Status;
     }
 }
 
-NTSTATUS STDCALL _find_item(device_extension* Vcb, root* r, traverse_ptr* tp, const KEY* searchkey, BOOL ignore, PIRP Irp, const char* func, const char* file, unsigned int line) {
+NTSTATUS find_item(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ root* r, _Out_ traverse_ptr* tp,
+                   _In_ const KEY* searchkey, _In_ BOOL ignore, _In_opt_ PIRP Irp) {
     NTSTATUS Status;
     BOOL loaded;
-//     KIRQL irql;
-    
-    TRACE("(%p, %p, %p, %p)\n", Vcb, r, tp, searchkey);
-    
+
     if (!r->treeholder.tree) {
-        Status = _do_load_tree(Vcb, &r->treeholder, r, NULL, NULL, &loaded, Irp, func, file, line);
+        Status = do_load_tree(Vcb, &r->treeholder, r, NULL, NULL, &loaded, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("do_load_tree returned %08x\n", Status);
             return Status;
@@ -506,30 +540,20 @@
         }
     }
 
-    Status = find_item_in_tree(Vcb, r->treeholder.tree, tp, searchkey, ignore, 0, Irp, func, file, line);
+    Status = find_item_in_tree(Vcb, r->treeholder.tree, tp, searchkey, ignore, 0, Irp);
     if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND) {
         ERR("find_item_in_tree returned %08x\n", Status);
     }
-    
-// #ifdef DEBUG_PARANOID
-//     if (b && !ignore && tp->item->ignore) {
-//         ERR("error - returning ignored item\n");
-//         int3;
-//     }
-// #endif
-    
+
     return Status;
 }
 
-NTSTATUS STDCALL _find_item_to_level(device_extension* Vcb, root* r, traverse_ptr* tp, const KEY* searchkey, BOOL ignore, UINT8 level,
-                                     PIRP Irp, const char* func, const char* file, unsigned int line) {
+NTSTATUS find_item_to_level(device_extension* Vcb, root* r, traverse_ptr* tp, const KEY* searchkey, BOOL ignore, UINT8 level, PIRP Irp) {
     NTSTATUS Status;
     BOOL loaded;
-    
-    TRACE("(%p, %p, %p, %p)\n", Vcb, r, tp, searchkey);
-    
+
     if (!r->treeholder.tree) {
-        Status = _do_load_tree(Vcb, &r->treeholder, r, NULL, NULL, &loaded, Irp, func, file, line);
+        Status = do_load_tree(Vcb, &r->treeholder, r, NULL, NULL, &loaded, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("do_load_tree returned %08x\n", Status);
             return Status;
@@ -536,37 +560,36 @@
         }
     }
 
-    Status = find_item_in_tree(Vcb, r->treeholder.tree, tp, searchkey, ignore, level, Irp, func, file, line);
+    Status = find_item_in_tree(Vcb, r->treeholder.tree, tp, searchkey, ignore, level, Irp);
     if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND) {
         ERR("find_item_in_tree returned %08x\n", Status);
     }
-    
+
     if (Status == STATUS_NOT_FOUND) {
         tp->tree = r->treeholder.tree;
         tp->item = NULL;
     }
-    
+
     return Status;
 }
 
-BOOL STDCALL _find_next_item(device_extension* Vcb, const traverse_ptr* tp, traverse_ptr* next_tp, BOOL ignore, PIRP Irp,
-                             const char* func, const char* file, unsigned int line) {
+BOOL find_next_item(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, const traverse_ptr* tp, traverse_ptr* next_tp, BOOL ignore, PIRP Irp) {
     tree* t;
-    tree_data *td, *next;
+    tree_data *td = NULL, *next;
     NTSTATUS Status;
     BOOL loaded;
-    
+
     next = next_item(tp->tree, tp->item);
-    
+
     if (!ignore) {
         while (next && next->ignore)
             next = next_item(tp->tree, next);
     }
-    
+
     if (next) {
         next_tp->tree = tp->tree;
         next_tp->item = next;
-        
+
 #ifdef DEBUG_PARANOID
         if (!ignore && next_tp->item->ignore) {
             ERR("error - returning ignored item\n");
@@ -573,67 +596,67 @@
             int3;
         }
 #endif
-        
+
         return TRUE;
     }
-    
+
     if (!tp->tree->parent)
         return FALSE;
-    
+
     t = tp->tree;
     do {
         if (t->parent) {
             td = next_item(t->parent, t->paritem);
-            
+
             if (td) break;
         }
-        
+
         t = t->parent;
     } while (t);
-    
+
     if (!t)
         return FALSE;
-    
-    Status = _do_load_tree(Vcb, &td->treeholder, t->parent->root, t->parent, td, &loaded, Irp, func, file, line);
+
+    Status = do_load_tree(Vcb, &td->treeholder, t->parent->root, t->parent, td, &loaded, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("do_load_tree returned %08x\n", Status);
         return FALSE;
     }
-    
+
     t = td->treeholder.tree;
-    
+
     while (t->header.level != 0) {
         tree_data* fi;
-       
+
         fi = first_item(t);
-        
-        Status = _do_load_tree(Vcb, &fi->treeholder, t->parent->root, t, fi, &loaded, Irp, func, file, line);
+
+        Status = do_load_tree(Vcb, &fi->treeholder, t->parent->root, t, fi, &loaded, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("do_load_tree returned %08x\n", Status);
             return FALSE;
         }
-        
+
         t = fi->treeholder.tree;
     }
-    
+
     next_tp->tree = t;
     next_tp->item = first_item(t);
-    
+
     if (!ignore && next_tp->item->ignore) {
         traverse_ptr ntp2;
         BOOL b;
-        
-        while ((b = _find_next_item(Vcb, next_tp, &ntp2, TRUE, Irp, func, file, line))) {
+
+        while ((b = find_next_item(Vcb, next_tp, &ntp2, TRUE, Irp))) {
             *next_tp = ntp2;
-            
+
             if (!next_tp->item->ignore)
                 break;
         }
-        
+
         if (!b)
             return FALSE;
     }
-    
+
 #ifdef DEBUG_PARANOID
     if (!ignore && next_tp->item->ignore) {
         ERR("error - returning ignored item\n");
@@ -640,26 +663,25 @@
         int3;
     }
 #endif
-    
+
     return TRUE;
 }
 
 static __inline tree_data* last_item(tree* t) {
     LIST_ENTRY* le = t->itemlist.Blink;
-    
+
     if (le == &t->itemlist)
         return NULL;
-    
+
     return CONTAINING_RECORD(le, tree_data, list_entry);
 }
 
-BOOL STDCALL _find_prev_item(device_extension* Vcb, const traverse_ptr* tp, traverse_ptr* prev_tp, BOOL ignore, PIRP Irp,
-                             const char* func, const char* file, unsigned int line) {
+BOOL find_prev_item(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, const traverse_ptr* tp, traverse_ptr* prev_tp, PIRP Irp) {
     tree* t;
     tree_data* td;
     NTSTATUS Status;
     BOOL loaded;
-    
+
     // FIXME - support ignore flag
     if (prev_item(tp->tree, tp->item)) {
         prev_tp->tree = tp->tree;
